/*
 Programme principal | Radix Sort 
 Editeur : Ajanohoun Jordy 
 Organisme : Polytech Sorbonne 
 Cours : Algorithme General by Cecile Braunstein  */


#include "rdxSort.h"
#include <time.h>

void printIntTab(const int *tab, const int SIZE);

int main(){

  srand(time(NULL));

  printf("\n\n----------------------------- PROGRAMME PRINCIPALE RADIX-SORT  -----------------------------\n\n");
  printf("Auteur : AJANOHOUN JORDY\n");
  printf("Organisme : Polytech Sorbonne\n");
  printf("Enseignante : Cecile Braunstein\n\n\n");

  char nomRdxFct[4][25] = {"rdxSortPosIntTab_Bi","rdxSortPosIntFile_Bi","rdxSortPosIntFile_De","rdxSortNegIntFile_De"};
  int N, k, puissance;
  int* tab = NULL;
  int i, j;
  
  printf("\n");

  for(j=0; j<3; j++){

    N = rand()%(15-5) +5;
    tab = (int *)malloc(N*sizeof(int));
    k = rand()%(7-1) +1;
    puissance = pow(10,k);
    
    for(i=0; i<N; i++){
      tab[i] = rand()%(-puissance+puissance/2 +1) - puissance/5;
    }
    
    printf("Le tableau a trier genere aleatoirement est le suivant : \n");
    printIntTab(tab,N);
    printf("\n");

    rdxSortIntChoix(tab,N,-1,j);    
    printf("Le tableau apres tri avec la fonction %s pour trier le sous tableau positif est : \n", nomRdxFct[j]);
    printIntTab(tab,N);
    printf("\n\n");


    printf("**************************************************************************************************************\n\n");

    free(tab);
  }

  printf("Le sous tableau negatif est toujours trié avec la fonction rdxSortNegIntFile_De !\n\n\n");
  
  return 0;
}


void printIntTab(const int *tab, const int SIZE){
  int i;
  for(i=0; i<SIZE; i++){
    printf("%d  ", tab[i]);
  }
  printf("\n");
}
