#include "queue.h"

Queue initQueue(){
  Queue start;
  start.head = NULL;
  start.tail = NULL;
  return start;
}

void enqueue(Queue * file, type_t type){

  QueueNode * node = (QueueNode *)malloc(sizeof(QueueNode));
  node -> type = type;
  node -> nextNode = NULL;

  if(file->tail){
    file -> tail -> nextNode = node;
    file -> tail = node;
  }
  else{
    file -> tail = node;
    file -> head = node;
  }
}

type_t dequeue(Queue * file){
  if(!(file -> head -> nextNode)){
    file -> tail = NULL;
  }
  type_t res = file -> head -> type;
  QueueNode * nodeH = file -> head;
  file -> head = file -> head -> nextNode;
  free(nodeH);
  return res;
}
