# ifndef QUEUE__H
# define QUEUE__H

#include <stdio.h>
#include <stdlib.h>

typedef int type_t;

typedef struct queueNode{
  type_t type;
  struct queueNode *nextNode;
}QueueNode;

typedef struct{
  QueueNode *head;
  QueueNode *tail;
}Queue;

Queue initQueue();

void enqueue(Queue * file, type_t type);

int dequeue(Queue * file);

# endif
